/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2025 KylinSoft  Co., Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */
#ifndef ACCESSIBILITY_H
#define ACCESSIBILITY_H

#include <QObject>
#include <QVBoxLayout>
#include <QWidget>
#include <QtPlugin>
#include <QImageReader>
#include <KSharedConfig>
#include <KConfigGroup>
#include <QDBusObjectPath>
#include <QProcess>
#include <QStringList>

#include "shell/interface.h"
#include "ukcccommon.h"
using namespace ukcc;

#include "kswitchbutton.h"
using namespace kdk;

#include "shell/interface.h"

//#define KWIN_DBUS_SERVER            "org.ukui.KWin"
//#define KWIN_DBUS_INTERFACE         KWIN_DBUS_SERVER
//#define KWIN_FILTER_INTERFACE       "org.ukui.colorfilter"
//#define KWIN_FILTER_PATH            "/ColorFilter"
//#define KWIN_EFFECTS_DBUS_INTERFACE "org.ukui.kwin.Effects"
//#define KWIN_EFFECT_PATH            "/Effects"
//#define MAGNIFIER_DBUS_SERVER       "org.ukui.magnifier"
//#define MAGNIFIER_DBUS_PATH         "/Magnifier"
//#define MAGNIFIER_DBUS_INTERFACE    MAGNIFIER_DBUS_SERVER
//#define STYLE_GSETTING_SCHEMA       "org.ukui.style"
#define STYLE_NAME_KEY              "style-name"
#define STYLE_NAME_CHANGE_KEY       "styleName"
#define ZOOM_LABEL_TRANSPARENT      0.35 * 255
#define COLOR_WHITE_NUMBER          255
#define COLOR_BALCK_NUMBER          0

namespace Ui {
class Accessibility;
}

class Accessibility : public QObject, CommonInterface
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.ukcc.CommonInterface")
    Q_INTERFACES(CommonInterface)

public:
    Accessibility();
    ~Accessibility();

    QString plugini18nName() Q_DECL_OVERRIDE;
    int pluginTypes() Q_DECL_OVERRIDE;
    QWidget *pluginUi() Q_DECL_OVERRIDE;
    const QString name() const  Q_DECL_OVERRIDE;
    bool isShowOnHomePage() const Q_DECL_OVERRIDE;
    QIcon icon() const Q_DECL_OVERRIDE;
    bool isEnable() const Q_DECL_OVERRIDE;

private:
    int                 m_pluginType;
    bool                m_firstLoad;
    bool                m_zoomSwitchSync        = false;
    QString             m_pluginName;

    Ui::Accessibility*  ui;
    QWidget*            m_pPluginWidget         = nullptr;
    QDBusInterface*     m_accessibilityInterface = nullptr;
    KSwitchButton*      m_pZoomSwitchButton     = nullptr;
    KSwitchButton*      m_pFilterSwitchButton   = nullptr;
    KSwitchButton*      m_pShortcutSwitchButton = nullptr;

private:
    void initUI();
    void initConnection();
    void initQGSettingsAndDBus();
    void initDefaultData();
    void renewZoomLabel_2Palette();

private slots:
    void setZoomMode(int index);
    void setFilterMode(int index);
    void setZoomSwitch(bool toggled);
    void setFilterSwitch(bool toggled);
    void setShortcutSwitch(bool enabled);
    void syncZoomComboBox(int mode);
    void syncZoomSwitch(bool status);
    void syncFilterSwitch(bool status);
    void syncShortcutSwitch(bool status);
    void syncFilterComboBox(QString type);
    void dataChanged(QString key);

};
#endif // ACCESSIBILITY_H
